/*
 * Soutezici 37
 * Uloha kontrola pravopisu uroven 4
 * Pouzil jsem kodovani PCLatin2
 * Dne 3.6.2000
 * pozn:Nefunguje zapisovani novyh slov do slovniku, ale kdyd pri jednom spusteni
 * zadate zapsat slovo do slovniku, tak se tam udrzi do konce prog
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <allegro.h>

#define MAX_SLOV 4096        //max. pocet slov ve slovniku, zacinajicich stejnym pism.

FILE *fr,*fw,*fs;            //soubor pro cteni ,zapis a slovnik
char filer[256],filew[265];  //jmena souboru pro cteni a zapis

typedef struct Slova_typ {
  char *s[MAX_SLOV];  //slova
  int pocet; //pocet slov;

} SLOVA,*P_SLOVA;

SLOVA slovnik[256];   //prvni index je ASCII hodnota pismene;
char pom_slovo[100];  //pomocny retezec pro vyhledavani slov
char akt_slovo[100];  //pomocny retezec pro vyhledavani slov   =
int pocet_pismen=0;   //pocet pismen v                        -/

char *nova_slova[1024];  //nova slova, zarazena do slovniku
int pocet_novych_slov=0; //pocet novyuch slov

int inter=0;          //jsme v interaktivnim rezimu?

char text_pred[100];  //text pred menenym slovem
char text_za[100];    //text po menenem slove

DIALOG nacti_slovo[]={
// proc             x   y   w   h   fg   bg   key     flags   d1   d2   dp   dp2   dp3
{ d_clear_proc},
{d_shadow_box_proc,10,180,620,120,255, 16},
{ d_ctext_proc,   320,190, 50, 15,  5, 16,   0,     000000,  0,   0,   "Zadejte nove slovo:"},
{ d_text_proc,     20,210, 15, 15,255, 16,   0,     000000,  0,   0,   text_pred},
{ d_edit_proc,    240,225,160, 15,  1, 16,   0,     000000,100,   0,   akt_slovo},
{ d_text_proc,     20,245, 15, 15,255, 16,   0,     000000,  0,   0,   text_za},
{ d_button_proc,  290,260, 60, 20,255, 16, 'o',     D_EXIT,  0,   0,   "&Ok"},
{ NULL}
};

char moznosti[6][100];

DIALOG vyber_slovo[]={
// proc             x   y   w   h   fg   bg   key     flags   d1   d2   dp   dp2   dp3
{ d_clear_proc},
{d_shadow_box_proc,210,80,220,220,255, 16},
{ d_text_proc,     220,90, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[0]},
{ d_button_proc,   340,88, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},
{ d_text_proc,     220,110, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[1]},
{ d_button_proc,   340,108, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},

{ d_text_proc,     220,130, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[2]},
{ d_button_proc,   340,128, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},
{ d_text_proc,     220,150, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[3]},
{ d_button_proc,   340,148, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},

{ d_text_proc,     220,170, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[4]},
{ d_button_proc,   340,168, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},
{ d_text_proc,     220,190, 15, 15,255, 16,   0,     000000,  0,   0,   moznosti[5]},
{ d_button_proc,   340,188, 60, 15,255, 16,   0,     D_EXIT,  0,   0,   "Toto"},

{ d_button_proc,   290,260, 60, 20,255, 16, 'z',     D_EXIT,  0,   0,   "&Zadne"},
{ NULL}
};



//zaradi slovo na jeho misto ve slovniku
void Zarad_slovo(char *word)
{
P_SLOVA akt=&(slovnik[(int) (unsigned char)word[0]]);;

if (akt->pocet==MAX_SLOV) {printf("Moc slov ve slovniku!\n");exit(3);}
akt->s[akt->pocet]=malloc(strlen(word)+1);
strcpy(akt->s[akt->pocet++],word);
}

// Vystori slovnik, vola pomocnou fci Zarad_slovo
void Vytvor_slovnik(void)

{
int n;
int c;
for (n=0;n<256;n++) slovnik[n].pocet=0;

while (c=fgetc(fs),c!=EOF) {

if (c!='\n') akt_slovo[pocet_pismen++]=c;
else {
  akt_slovo[pocet_pismen]='\0';
  Zarad_slovo(akt_slovo);
  pocet_pismen=0;
}
}
}

int Zkus_nova(void)
{
int n;
for (n=0;n<pocet_novych_slov;n++)
  if (!strcmp(nova_slova[n],pom_slovo)) return 1;
return 0;
}

int Najdi_slovo(char *word)
/* Vraci 1-slovo nalezeno
   Vraci 0-slovo nenalezeno*/
{
P_SLOVA akt;
int left=0,right,now;
int ret;

strcpy(pom_slovo,word);
strlwr(pom_slovo);
akt=&(slovnik[(int) (unsigned char)pom_slovo[0]]);

//protoze slova jsou setridena, pouziji binarni hledani

right=akt->pocet-1;
while (left<right) {
  now=(right+left)>>1;
  ret=strcmp(pom_slovo,akt->s[now]);
  if (ret==0) return 1;
  if (ret>0) {if (left==now) return Zkus_nova(); else left=now;}
  if (ret<0) {if (right==now) return Zkus_nova(); else right=now;}
}
return Zkus_nova();
}

int qsort_stringlist(void *e1, void *e2)
{
   return strcmp(*(char **)e1, *(char **)e2);
}


int main(int argc,char *argv[])
{
int c;


if (argc==1) {
inter=1;
allegro_init();
install_timer();
install_mouse();
install_keyboard();
set_gfx_mode(GFX_AUTODETECT,640,480,0,0);
set_palette(desktop_palette);

file_select("Vyberte soubor pro cteni(*.*)",filer,NULL);
file_select("Vyberte soubor pro zapis(*.*)",filew,NULL);
clear(screen);
}
else if (argc<3) {
printf("Spatny pocet parametru!");
return 1;
}
else {
strcpy(filer,argv[1]);
strcpy(filew,argv[2]);
}

if ((fr=fopen(filer,"r"))==NULL) {
  printf("Nemohu otevrit soubor %s!\n",argv[1]);
  return 3;  //chyba,konec
}
if ((fw=fopen(filew,"w"))==NULL) {
  printf("Nemohu otevrit soubor %s!\n",argv[2]);
  return 3;  //chyba,konec
}
if ((fs=fopen("dict.txt","r"))==NULL) {
  printf("Nemohu otevrit soubor dict.txt!\n");
  return 3;  //chyba,konec
}


Vytvor_slovnik();

while (c=fgetc(fr),c!=EOF) {
  if (c=='\n' || ispunct(c) || isspace(c) || isdigit(c)) {
    if (pocet_pismen) {
      akt_slovo[pocet_pismen]='\0';
      if (Najdi_slovo(akt_slovo)) fprintf(fw,"%s%c",akt_slovo,c);
      else {
        if (inter) {
          unsigned long pos=ftell(fr);
          int pocet;
          int celkem_dop=(pos>50) ? 50:pos;
          int pismen_vepredu;
          int pismen_vzadu;
          int ret;
          int cc; //znak pro cteni ze souboru
          //zobrazit okoli a dovolit prepst
          //prepsane slovo se take kontroluje
          do {
          ret=alert3("Nesledujici slovo nebyla nalezeno ve slovniku:",akt_slovo,"Prejete si ho prepsat?","&Ano","&Ne","&Vybrat",'a','n','v');
          if (ret==1) {

            //tohle bude asi dost necitelny.Jde o to, vyplnit retezce text_pred a
            // text_za do tabulky pro prepsani slova.
            // Text pred: V souboru se posunu o 50 dopredu(kdyz to nejde o tolik, tak o min,
            // najdu 1. zacatek slova a vypisu do a cely retezec do akt. pozice

            //Text za: prectu 50 pismen, kdyz to nejde, tak mene a pouziju je vsechny
            pos=ftell(fr);
            celkem_dop=(pos>50) ? 49:pos;
            pismen_vepredu=0;
            pocet=0;
            fseek(fr,-celkem_dop,SEEK_CUR);

            //Text_pred
            strcpy(text_pred,"Text pred:");
            pismen_vepredu=10;
            if (celkem_dop==49) {
              while (cc=fgetc(fr),pocet++,pocet<celkem_dop) if (ispunct(cc) || isspace(cc) || cc=='\n') break;
              pocet++;
            }
            while (cc=fgetc(fr),pocet++,pocet<celkem_dop) text_pred[pismen_vepredu++]=cc;
            text_pred[pismen_vepredu++]='\0';

            //Text_za
            fseek(fr,pos,SEEK_SET);
            strcpy(text_za,"Text za:");
            pismen_vzadu=8;
            pocet=0;
            celkem_dop=50;
            while (cc=fgetc(fr),pocet++,pocet<celkem_dop && cc!=EOF) text_za[pismen_vzadu++]=cc;
            text_za[pismen_vzadu++]='\0';

            //zjisti nove slovo
            do_dialog(nacti_slovo,-1);
            clear(screen);
          }
          else if (ret==3) {
            int n,min;
            P_SLOVA akt;
            strcpy(pom_slovo,akt_slovo);
            strlwr(pom_slovo);
            akt=&(slovnik[(int) (unsigned char)pom_slovo[0]]);
            n=0;
            while (strcmp(pom_slovo,akt->s[n])>0) if (++n==akt->pocet) break;
            if (n!=akt->pocet);
            min=n-3;
            if (min<0) min=0;
            strcpy(moznosti[0],(min<akt->pocet) ? akt->s[min] : "Neni");
            strcpy(moznosti[1],(min+1<akt->pocet) ? akt->s[min+1] : "Neni");
            strcpy(moznosti[2],(min+2<akt->pocet) ? akt->s[min+2] : "Neni");
            strcpy(moznosti[3],(min+3<akt->pocet) ? akt->s[min+3] : "Neni");
            strcpy(moznosti[4],(min+4<akt->pocet) ? akt->s[min+4] : "Neni");
            strcpy(moznosti[5],(min+5<akt->pocet) ? akt->s[min+5] : "Neni");
            ret=do_dialog(vyber_slovo,-1);
            ret-=3;
            if (ret<=10) {//Uzivatel vybral nejake slovo(0-1.sl ,2-2.sl 4-3.sl. atd
              ret/=2;
              strcpy(akt_slovo,akt->s[min+ret]);
            }
            clear(screen);

          }
          else break;
          } while (!Najdi_slovo(akt_slovo));
          fseek(fr,pos,SEEK_SET);
          if (Najdi_slovo(akt_slovo)) fprintf(fw,"%s%c",akt_slovo,c);
          else {
            if (alert("Prejete si toto slovo",akt_slovo,"zaradit do slovniku?","&Ano","&Ne",'a','n')==2) {//Ne
              fprintf(fw,"#%s%c",akt_slovo,c);
            }
            else {
              nova_slova[pocet_novych_slov]=malloc(sizeof(akt_slovo)+1);
              strcpy(nova_slova[pocet_novych_slov],akt_slovo);
              strlwr(nova_slova[pocet_novych_slov++]);
              fprintf(fw,"%s%c",akt_slovo,c);
            }
          }
        }
        else fprintf(fw,"#%s%c",akt_slovo,c);
      }

      pocet_pismen=0;
    }
    else fputc(c,fw);
  }
  else akt_slovo[pocet_pismen++]=c;
}

if (inter) alert("Kontrola pravopisu byla dokoncena.",NULL,NULL,"&Ok",NULL,'o',0);

return 0;
}
